
#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    if {![info exists rootNameList]} {set rootNameList [list EXPERIMENTS CURRENT_EXPERIMENT]}
    if {![info exists typeList]} {set typeList [list string binary short long float]}

    variable nodeList {}
    variable valueList {}

    variable rootName [first $rootNameList]
    variable nodeName [first $nodeList]
    variable valueName [first $valueList]

    variable pattern "NULL"
    variable DBdata "default"
    variable DBtype [first $typeList]

    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag

       variable rootName
       variable nodeName
       variable valueName
       variable DBdata
       variable DBtype
       variable pattern

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
         InsertLog "rootName=$rootName; nodeName=$nodeName; valueName=$valueName"
         InsertLog "pattern=$pattern; DBtype=$DBtype; DBdata=$DBdata"
    }


    proc do_nodes {Path Pattern} {
        global errorCode errorInfo
        global MIDAS_DataBaseCode
        variable nodeList
        variable nodeName

        set nodeList {}

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_nodes $Path $Pattern} m]
        if {$rc != 0} {
            InsertLog "nodes returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode >= 0} then {
                if {$MIDAS_DataBaseCode == 0} then {
                     InsertLog "$Path contains nodes"
                     set nodeList {}
                     foreach item $m {lappend nodeList $item; InsertLog "$item"}
                     if {$nodeName == ""} then {set nodeName [first $nodeList]} \
                           else {set nodeName $nodeName/[first $nodeList]}
                } else {
                     InsertLog "$Path contains no nodes"
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path access error: error [second $m]; [third $m]"
            }
        }
    }

    proc do_set {Path Value Data DBtype} {
        global errorCode errorInfo
        global MIDAS_DataBaseCode

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path $Value {$Data} $DBtype} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$Value == "NULL"} then {InsertLog "$Path created"} \
                     else {InsertLog "$Path: $Value set to $Data (DBtype = $DBtype)"}
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $Value NOT set: error [second $m]; [third $m]"
            }
        }
    }

    proc do_get {Path Value} {
        global errorCode errorInfo
        global MIDAS_DataBaseCode
        variable DBdata

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_get $Path $Value} m]
        if {$rc != 0} {
            InsertLog "get returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                InsertLog "$Path: $Value = $m"
                set DBdata "$m"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $Value NOT available: error [second $m]; [third $m]"
            }
        }
    }

    proc do_delete {Path Value} {
        global errorCode errorInfo
        global MIDAS_DataBaseCode

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_delete $Path $Value} m]
        if {$rc != 0} {
            InsertLog "delete returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$Value == "NULL"} then {InsertLog "$Path deleted"} else {InsertLog "$Path: $Value deleted"}
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $Value NOT deleted: error [second $m]; [third $m]"
            }
        }
    }

    proc do_type {Path Value} {
        global errorCode errorInfo
        global MIDAS_DataBaseCode
        variable DBtype

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_type $Path $Value} m]
        if {$rc != 0} {
            InsertLog "type returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                InsertLog "$Path: $Value type = $m"
                set DBtype $m
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $Value type NOT available: error [second $m]; [third $m]"
            }
        }
    }

    proc do_values {Path Pattern} {
        global errorCode errorInfo
        global MIDAS_DataBaseCode
        variable valueList
        variable valueName

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_values $Path $Pattern} m]
        if {$rc != 0} {
            InsertLog "values returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                set valueList {}
                if {[llength $m] == 0} then {InsertLog "$Path contains NO values"} else {
                    InsertLog "$Path contains values"
                    foreach item $m {lappend valueList $item; InsertLog "$item"}
                }
                set valueName [first $valueList]
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path access error: error [second $m]; [third $m]"
            }
        }
    }

     proc do_nodenames {n} {
         variable nodeName
         
         set nodeName [join [lreplace [split $nodeName /] end end $n] /]
     }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS

       variable rootName
       variable nodeName
       variable valueName
       variable DBdata
       variable DBtype
       variable pattern

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   ROOTNAME  {set rootName [lindex $w 1]}
                   NODENAME  {
                     if {[llength $w] == 1} {set nodeName ""} else {set nodeName [lindex $w 1]}
                   }
                   PATTERN   {set pattern [lindex $w 1]}
                   VALUENAME {set valueName [lindex $w 1]}
                   TYPE      {set DBtype [lindex $w 1]}
                   DATA      {set DBdata [string range $w 5 end]}

                   NODENAMES {do_nodenames [lindex $w 1]}
                   VALUENAMES {set valueName [lindex $w 1]}

                SET      {do_set $rootName/$nodeName $valueName $DBdata $DBtype}
                CREATE   {do_set $rootName/$nodeName NULL NULL NULL}

                GET      {do_get $rootName/$nodeName $valueName}

                DELETE   {do_delete $rootName/$nodeName $valueName}
                DELALL   {do_delete $rootName/$nodeName NULL}

                GETTYPE  {do_type $rootName/$nodeName $valueName}

                VALUESM   {do_values $rootName/$nodeName  $pattern}
                VALUESALL {do_values $rootName/$nodeName  NULL}

                SHOWALL  {do_nodes $rootName/$nodeName NULL}
                SHOWM    {do_nodes $rootName/$nodeName $pattern}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
    }

}   ;# end of if {$started == 0}



